﻿using UnityEngine;
using System.Collections;
using UnityEngine.UI;
using System.Collections.Generic;

public class ImportantInteractable : Interactable
{
    public int stage = 0;
    public int[] stage_jumps = { 0 };
    public AudioClip audio;

    // Use this for initialization
    void Start()
    {
        this.isMultiline = true;
    }

    // Update is called once per frame
    void Update()
    {

    }

    public override Object doInteract(GameObject sender, bool autoStageInc = true)
    {
        List<string> to_send = new List<string>();
        List<bool> is_player_send = new List<bool>();
        for (int i = stage_jumps[stage]; i < stage_jumps[stage + 1]; i++)
        {
            print(i);
            if (multilines[i][0] == '[')
            {
                if(multilines[i].Contains("ITEM: "))
                {
                    int id;
                    string spriteLoc;
                    string message;
                    bool showMessage;
                    string[] splitmsg = multilines[i].Split(';');
                    id = int.Parse(splitmsg[1]);
                    spriteLoc = splitmsg[2];
                    showMessage = bool.Parse(splitmsg[3]);
                    message = splitmsg[4];
                    print(spriteLoc);
                    Sprite loc = Resources.Load<Sprite>(spriteLoc.Split('.')[0]);
                    dialogue.GetComponent<DialogueMaster>().SendMessage(new ItemMessage(id, portrait, loc, showMessage, message));
                }
                else if (multilines[i].Contains("CHOICE: "))
                {
                    string message;
                    string option1;
                    string option2;
                    string result1;
                    string result2;
                    string[] splitmsg = multilines[i].Split(';');
                    message = splitmsg[1];
                    option1 = splitmsg[2];
                    result1 = splitmsg[3];
                    option2 = splitmsg[4];
                    result2 = splitmsg[5];
                    print(result1);
                    print(result2);
                    dialogue.GetComponent<DialogueMaster>().SendMessage(new ConvoMessage(message,portrait,option1,result1,option2,result2));
                }
                else if (multilines[i].Contains("DESTROY"))
                {
                    dialogue.GetComponent<DialogueMaster>().SendMessage(new DestroyMessage(this.gameObject));
                }
                else if (multilines[i].Contains("PLAY: "))
                {
                    dialogue.GetComponent<DialogueMaster>().SendMessage(new SoundMessage(this.audio));
                }
            }
            else
            {
                print("sending message");
                print(multilines[i]);
                print(isPlayer[i]);
                dialogue.GetComponent<DialogueMaster>().SendMessage(new DialogueMessage(multilines[i], isPlayer[i], portrait, speakingAudio));
            }
        }
        if(stage < stage_jumps.Length - 2 && autoStageInc)
        {
            stage++;
        }
        return new Object();
    }
}
